



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#线程 ---- 线程同步详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#线程 ---- 线程同步详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:43:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>线程同步</strong></p>
<p><strong>说明：接上一篇，注意分享线程同步的必要性和线程同步的方法。</strong></p>
<p><strong>测试代码下载：https://github.com/EkeSu/C-Thread-synchronization-C-.git</strong></p>
<p>一、什么是线程同步：</p>
<p>在同一时间只允许一个线程访问资源的情况称为线程同步。</p>
<p>二、为什么需要线程同步：</p>
<ul><li>避免竞争条件；</li>
<li>确保线程安全；（如果两个线程同时访问一个资源并对那个资源做修改，就不安全了）</li></ul>
<p>现在的计算机变得越来越多核，每一个CPU可以独立工作，但是对于内存和外部资源、数据库的访问却可能因为不同线程的访问使数据产生异常，常见的例子就是银行的转账的例子不再赘述。</p>
<p>三、线程同步的方法：</p>
<ul><li>同步代码中重要的部分；</li>
<li>使对象不可改变；</li>
<li>使用线程安全包装器；
<p>注意：局部变量、方法参数和返回值是放在堆栈中的，本身是线程安全的。</li></ul>
<p>四、线程不安全的演示：</p>
<p>背景：在数据库的user_blance表插入两条数据，两人的balance值都为1000.00，整个user_balance表的balance总值为2000.00</p>
<div>
<div>
<pre class="prettyprint linenums">        static string connectionStr = "Server=127.0.0.1;Port=3306;Stmt=;Database=exe_dev; User=root;Password=123456";<br />
        public static void UnSafeThread() {<br />
            Thread ThreadOne = new Thread(new ThreadStart(DrawMoney));<br />
            ThreadOne.Name = "A001";

            Thread ThreadTwo = new Thread(new ThreadStart(DrawMoney));<br />
            ThreadTwo.Name = "A002";

            ThreadOne.Start();<br />
            ThreadTwo.Start();<br />
        }

        private static void DoDrawMoney()<br />
        {<br />
            Random random = new Random();<br />
            int money = random.Next();

            string userId = Thread.CurrentThread.Name;<br />
            string selectSql = "select balance from user_balance where user_id=@UserId";<br />
            string updateSql = "update user_balance set balance=@Balance+@Money where user_id=@UserId";<br />
            string updateSql2 = "update user_balance set balance=@Balance-@Money where user_id&lt;&gt;@UserId";<br />
            using (MySqlConnection conn= MySqlConnectionHelper.OpenConnection(connectionStr))<br />
            {<br />
                var balance = conn.ExecuteScalar(selectSql, new { UserId = userId });<br />
                if (balance != null)<br />
                {<br />
                    conn.Execute(updateSql, new { Money = money, Balance=balance, UserId = userId });<br />
                    conn.Execute(updateSql2, new { Money = money, Balance = balance, UserId = userId });<br />
                }<br />
            }<br />
        }

        private static void DrawMoney() {<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                DoDrawMoney();<br />
            }<br />
        }</pre>
</div>
</div>
<p>运行结果：</p>
<div><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1063391/201811/1063391-20181115080842651-543411519.png" /></div>
<p>程序中有三条线程在跑：两条支线程，一条主线程，主线程负责统计钱的总数，两条支线程模拟两个人赚钱，赚过来赚过去，哈哈哈，依据查询成果可以看到，钱的总数原本是2000.00，但是之后开始减少。当然上面的异常也可以通过加事务解决，或者改变sql的实现方式balance=balance+money,不过这个不是我们讨论的重点，不展开。</p>
<p><strong>&nbsp;五、线程同步:</strong><br /><strong>1、MethodImplAttribute:同步方法</strong></p>
<ul><li><strong> 对象：方法。</strong></li>
<li><strong> 使用方式：放在方法上，作为方法的属性</strong></li></ul>
<p>MethodImplAttribute是一个属性，它用来告诉CLR方法是如何实现的，MethodImplAttribute的一个构造函数把MethodImplOptions的枚举值作为参数，MethodImplOptions的枚举值Synchronized告诉CLR，这个方法该一次性只能在一个线程上执行。 静态方法在类型上锁定，而实例方法在实例上锁定。 只有一个线程可在任意实例函数中执行，且只有一个线程可在任意类的静态函数中执行。</p>
<p>使用方式：在需要同步的方法上添加属性</p>
<pre class="prettyprint linenums"><strong>[MethodImpl(MethodImplOptions.Synchronized)]</strong></pre>
<div>
<pre class="prettyprint linenums">        [MethodImpl(MethodImplOptions.Synchronized)]<br />
        private static void DoDrawMoney()<br />
        {<br />
            Random random = new Random();<br />
            int money = random.Next();

            string userId = Thread.CurrentThread.Name;<br />
            string selectSql = "select balance from user_balance where user_id=@UserId";<br />
            string updateSql = "update user_balance set balance=@Balance+@Money where user_id=@UserId";<br />
            string updateSql2 = "update user_balance set balance=balance-@Money where user_id&lt;&gt;@UserId";<br />
            using (MySqlConnection conn= MySqlConnectionHelper.OpenConnection(connectionStr))<br />
            {<br />
                var balance = conn.ExecuteScalar(selectSql, new { UserId = userId });<br />
                if (balance != null)<br />
                {<br />
                    conn.Execute(updateSql, new { Money = money, Balance=balance, UserId = userId });<br />
                    conn.Execute(updateSql2, new { Money = money, Balance = balance, UserId = userId });<br />
                }<br />
            }<br />
        }</pre>
</div>
<p><strong>&nbsp;2、SynchronizationAttribute 同步方法----同步上下文：</strong></p>
<ul><li><strong> 对象：非静态类。</strong></li>
<li><strong> 使用方式：放在<strong>非静态类</strong>上，作为<strong>非静态类</strong>的属性，同时非静态类需要继承【ContextBoundObject】</strong></li></ul>
<p>代码演示（其余部分和不安全的演示代码完全一样）：</p>
<div>
<pre class="prettyprint linenums">    [Synchronization]<br />
    class ThreadTestForSynchronization : ContextBoundObject<br />
    {</pre>
</div>
<p>上下文是一组属性或使用规则，这组属性或使用规则对执行时的相关对象都是通用的。我的理解是这些组成了程序运行的环境，我们使用【Synchronization】来在上下文中添加规则【ThreadTestForSynchronization】类是需要线程同步的，所以程序在运行的时候就是线程同步的。</p>
<p>注意：当前我使用的环境是VS2017, .Net Framework4.61，C#版本应该是6.0，SynchronizationAttribute属性和更早版本是发生了很大变化，更早版本的构造函数需要填入一个枚举值。</p>
<p><strong>&nbsp;3、使用Monitor同步----同步重要代码块：</strong></p>
<ul><li><strong>对象：代码块；</strong></li>
<li><strong>使用方式：使用Monitor.Enter(object obj)，Monitor.Exit(object obj);这两个是配套使用的，两个方法之间是需要同步的重要代码块，Enter放入的对象和Exit释放的对象应该一致。Enter使对象获得锁，Exit释放锁。</strong></li>
<li><strong>注意事项：这两个方法的参数是object,所以不能锁住值类型参数，因为会导致发生装箱，装箱之后的数值是一样的，但是已经不是同一个东西了。</strong></li></ul>
<p>代码演示（下面的例子锁住number会报错，因为发生装箱）：</p>
<div>
<pre class="prettyprint linenums">        private int number;

        public void MonitorThread()<br />
        {<br />
            Thread ThreadOne = new Thread(new ThreadStart(PrintNumber));<br />
            ThreadOne.Name = "梁山伯";

            Thread ThreadTwo = new Thread(new ThreadStart(PrintNumber));<br />
            ThreadTwo.Name = "祝英台";

            ThreadOne.Start();<br />
            ThreadTwo.Start();<br />
        }

        private void PrintNumber()<br />
        {<br />
            Console.WriteLine(string.Format("Thread {0} enter Method:",Thread.CurrentThread.Name));<br />
            Monitor.Enter(this);<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                Console.WriteLine(string.Format("Thread {0} increase number value:{1}", Thread.CurrentThread.Name, number++));<br />
            }<br />
            Monitor.Exit(this);<br />
            Console.WriteLine(string.Format("Thread {0} exit Method:", Thread.CurrentThread.Name));<br />
        }</pre>
</div>
<p>输出结果会是很工整的，占篇幅就不贴出来了。</p>
<p>Monitor.Enter()方法是去争取锁，还有另外一个方法是可以去争取锁并且进行等待的，就是TryEnter()方法，该方法可以有一个返回值，返回是否成功获得锁。同时该方法有三个重载：<br />bool TryEnter(object obj);&nbsp; &nbsp;---- 有返回值不等待</p>
<p>bool TryEnter(object obj, int millisecondsTimeout);&nbsp; ----- 有返回值且会等待锁</p>
<p>void TryEnter(object obj, TimeSpan timeout, ref bool lockTaken);&nbsp; &nbsp;----- 等待锁，成功则返回true到lockTaken.</p>
<p>下面看一下被改编的代码：</p>
<div>
<pre class="prettyprint linenums">        private void PrintNumber()<br />
        {<br />
            Console.WriteLine(string.Format("Thread {0} enter Method:", Thread.CurrentThread.Name));<br />
            <strong>bool isLock = Monitor.TryEnter(this,1000</strong><strong>);</strong><br />
            Console.WriteLine(string.Format("Thread {0} Get Lock {1}", Thread.CurrentThread.Name, isLock));<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                Thread.Sleep();<br />
                Console.WriteLine(string.Format("Thread {0} increase number value:{1}", Thread.CurrentThread.Name, number++));<br />
            }

            <strong>if (isLock)<br />
            {<br />
                Monitor.Exit(this</strong><strong>);<br />
            }</strong>

            Console.WriteLine(string.Format("Thread {0} exit Method:", Thread.CurrentThread.Name));<br />
        }</pre>
</div>
<p>演示结果：</p>
<div>
<pre class="prettyprint linenums">Thread 梁山伯 enter Method:<br />
Thread 梁山伯 Get Lock True<br />
Thread 祝英台 enter Method:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 increase number value:<br />
Thread 祝英台 Get Lock False<br />
Thread 梁山伯 increase number value:<br />
Thread 梁山伯 exit Method:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 increase number value:<br />
Thread 祝英台 exit Method:</pre>
</div>
<p><strong>分析：线程梁山伯先进入方法PrintNumber，它先获得锁，并且去执行函数，线程祝英台等待的时间为1000毫秒，线程祝英台每次循环都要睡眠100毫秒，循环10次需要睡眠1000毫秒，所以线程祝英台等待1000毫秒是无法获得锁的，那么线程祝英台什么时候执行呢，就是趁着线程梁山伯睡眠的时候执行，所以等待1000毫秒之后，线程祝英台趁梁山伯睡眠的时候执行了。如果我们把祝英台等待锁的时间延长到2000毫秒，那么她就可以等待锁成功。需要注意的是，等待时间是1000毫秒的时候祝英台是没有获得锁的，所以不能执行Monitor.Exit(this)操作，没有获得锁自然无法获得锁，所以需要加一个 if 的判断。</strong></p>
<p><strong>笔者理解：线程梁山伯睡眠的时候祝英台开始执行了，但是并没有获得锁，就进入了被保护的代码块，说明，线程睡眠的时候是会去释放锁，睡眠之后是或重新获得锁的，这里面应该有复杂的机制处理，值得研究。</strong></p>
<p><strong>4、使用Monitor同步重要代码块，并使用Wait,Pulse方法做线程间的交互-----等待和发出脉冲机制：</strong></p>
<ul><li><strong>对象：代码块；</strong></li>
<li><strong>使用方式：Wait,Pulse在Enter和Exit方法之间调用，Wait方法：当在对象上调用Wait方法时，正在访问被Monitor对象的线程会释放锁并将进入等待状态（包括调用它的线程自己）；Pulse方法：发出一个信号通知正在等待的线程可以继续执行了，即等待的线程可以重新竞争获得锁继续执行。</strong></li>
<li><strong>个人对获得锁的理解：锁就是权力，有锁的人就有权力执行程序</strong></li></ul>
<p>演示程序：</p>
<div>
<pre class="prettyprint linenums">    class ThreadTestForMonitorWait<br />
    {<br />
        private int result;

        private LockData lockData;<br />
        public ThreadTestForMonitorWait()<br />
        {<br />
            this.lockData = new LockData();<br />
        }

        public void MonitorWaitThread()<br />
        {<br />
            Thread ThreadOne = new Thread(new ThreadStart(WaitFirstThread));<br />
            ThreadOne.Name = "WaitFirstThread";

            Thread ThreadTwo = new Thread(new ThreadStart(PulseFirstThread));<br />
            ThreadTwo.Name = "PulseFirstThread";

            ThreadOne.Start();<br />
            ThreadTwo.Start();<br />
        }

        private void WaitFirstThread()<br />
        {<br />
            Monitor.Enter(lockData);<br />
            Console.WriteLine(string.Format("Thread {0} enter MonitorWaitThread",Thread.CurrentThread.Name));<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                Monitor.Wait(lockData);<br />
                Console.WriteLine(string.Format("Thread {0} increase number value {1}", Thread.CurrentThread.Name, result++));<br />
                Monitor.Pulse(lockData);<br />
            }

            Console.WriteLine(string.Format("Thread {0} exit MonitorWaitThread", Thread.CurrentThread.Name));<br />
            Monitor.Exit(lockData);<br />
        }

        private void PulseFirstThread()<br />
        {<br />
            Monitor.Enter(lockData);<br />
            Console.WriteLine(string.Format("Thread {0} enter MonitorWaitThread", Thread.CurrentThread.Name));<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                Monitor.Pulse(lockData);<br />
                Console.WriteLine(string.Format("Thread {0} increase number value {1}", Thread.CurrentThread.Name, result++));<br />
                Monitor.Wait(lockData);<br />
            }

            Console.WriteLine(string.Format("Thread {0} exit MonitorWaitThread", Thread.CurrentThread.Name));<br />
            Monitor.Exit(lockData);<br />
        }<br />
    }

    public class LockData { }</pre>
</div>
<p>运行结果：</p>
<div>
<pre class="prettyprint linenums">Thread WaitFirstThread enter MonitorWaitThread<br />
Thread PulseFirstThread enter MonitorWaitThread<br />
Thread PulseFirstThread increase number value<br />
Thread WaitFirstThread increase number value<br />
Thread PulseFirstThread increase number value<br />
Thread WaitFirstThread increase number value<br />
Thread PulseFirstThread increase number value<br />
Thread WaitFirstThread increase number value<br />
Thread PulseFirstThread increase number value<br />
Thread WaitFirstThread increase number value<br />
Thread PulseFirstThread increase number value<br />
Thread WaitFirstThread increase number value<br />
Thread WaitFirstThread exit MonitorWaitThread<br />
Thread PulseFirstThread exit MonitorWaitThread</pre>
</div>
<p>可见：运行结果是很工整的，在上面的程序中，WaitFirstThread&nbsp;方法先被调用， WaitFirstThread 进入循环会调用Wait方法,这个时候他会失去锁，因此无法继续执行程序，而后方法&nbsp;PulseFirstThread 被调用，它所在的线程获得锁，不管三七二十一先来发出一个脉冲通知正在被锁定的线程：兄弟你可以继续竞争获得锁了，在一次循环的末尾它又调用了Wait方法，使自己失去锁，其他的线程可以竞争得到锁，所以接着&nbsp;WaitFirstThread 所在的线程就获得了锁，整个过程就变成两个线程之间锁给来给去，非常恩爱。</p>
<p><strong>问题：其实这个程序是有问题的，就是必须要线程WaitFirstThread先执行，先释放锁，否则若是PulseFirstThread先执行，它先通知其他线程可以竞争锁了，之后执行一次循环把自己的锁释放掉，而线程竞争得到锁之后干的第一件事就是释放锁，这样就大家都没有锁了，死锁就产生了。有兴趣可以试试看。</strong></p>
<p><strong>5.使用lock关键字同步重要代码块 ---- 一块封装了Monitor的语法糖。</strong></p>
<p>直接代码演示（改一下Monitor的PrintNumber方法的写法就行）：</p>
<div>
<pre class="prettyprint linenums">        private void PrintNumber()<br />
        {<br />
            Console.WriteLine(string.Format("Thread {0} enter Method:", Thread.CurrentThread.Name));<br />
            lock (this)<br />
            {<br />
                for (int i = ; i &lt; ; i++)<br />
                {<br />
                    Console.WriteLine(string.Format("Thread {0} increase number value:{1}", Thread.CurrentThread.Name, number++));<br />
                }<br />
            }<br />
            Console.WriteLine(string.Format("Thread {0} exit Method:", Thread.CurrentThread.Name));<br />
        }</pre>
</div>
<p>笔者觉得，比较好用的自然是lock，其实我几乎没有见过用Monitor的，但是一定要学会使用Monitor。</p>
<p><strong>&nbsp;6.使用ReaderWriterLock锁定文件：</strong></p>
<p><strong>我们一定都遇到过要写入一个文件返回该文件已经被其他程序锁定的错误，这个就是无法获得写锁，增加这个锁定可以防止这样的错误发生，使获得文件的写锁更有序。</strong></p>
<p><strong>对象：文件；</strong></p>
<p><strong>使用方式：</strong></p>
<pre class="prettyprint linenums"><strong>AcquireWriterLock(100);  尝试获取文件写锁；<br /></strong></pre>
<pre class="prettyprint linenums"><strong>ReleaseWriterLock();   释放文件写锁。</strong></pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<p>代码演示（运行时可以把下面绿色的代码注释掉以做比较会比较直观）：</p>
<div>
<pre class="prettyprint linenums">        private void WriterFileLock()<br />
        {<br />
            try<br />
            {<br />
                <strong>rwl.AcquireWriterLock(</strong><strong>100);<br />
                </strong>using (StreamWriter writer = new StreamWriter("@ReadWriterLokTest.text"))<br />
                {<br />
                    for (int i = ; i &lt; ; i++)<br />
                    {<br />
                        writer.WriteLine(i);<br />
                    }<br />
                }<br />
                Console.WriteLine("File Writer Finish");<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                Console.WriteLine(ex.Message);<br />
            }<br />
            finally<br />
            {<br />
                <strong>rwl.ReleaseWriterLock();</strong><br />
            }<br />
        }</pre>
</div>
<p>7、其他同步方式：<br /><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1063391/201811/1063391-20181122074212283-362007888.png" /></p>
<p>（图片来源：C#线程参考手册-清华大学出版社）</p>
<p>7.1 使用ManualResetEvent 同步</p>
<p>先看代码演示：</p>
<div>
<pre class="prettyprint linenums">        static ManualResetEvent manualResetEvent = new ManualResetEvent(false);<br />
        static Stopwatch stopwatch = new Stopwatch();

        public static void ManualResetEventThread()<br />
        {<br />
            stopwatch.Start();<br />
            var success = manualResetEvent.WaitOne(, false);<br />
            Console.WriteLine(Thread.CurrentThread.GetHashCode()+"获取信号:" + success + ",时间:"+ stopwatch.Elapsed);

            manualResetEvent.Set();

            success = manualResetEvent.WaitOne(, false);<br />
            Console.WriteLine(Thread.CurrentThread.GetHashCode() + "获取信号:" + success + ",时间:" + stopwatch.Elapsed);<br />
        }</pre>
</div>
<p>输出结果：</p>
<div>
<pre class="prettyprint linenums">1获取信号:False,时间:::01.0425731<br />
1获取信号:True,时间:::01.0655502</pre>
</div>
<p>ManualResetEvent 有两个方法：<br />Set():使状态变成有信号；</p>
<p>ReSet():使状态变成无信号。</p>
<p>其实ManualResetEvent 只是很简单的在不同线程同步了一个信号而已，并不会阻碍线程的向下继续执行，而WaitOne方法可以设置等待线程获取信号的时间，这个方法可以延缓线程的执行（一般不要这么玩）。</p>
<p>在使用上，可以根据WaitOne获取的状态来判断当前线程要不要继续执行。</p>
<p>另外需要介绍一下WaitAll和WaitAny的方法，首先是WaitAll:</p>
<p>我们先定义了三个方法：</p>
<div>
<pre class="prettyprint linenums">        private static void PrintOne()<br />
        {<br />
            manualResetEvent1.Set();<br />
        }<br />
        private static void PrintTwo()<br />
        {<br />
            manualResetEvent2.Set();<br />
        }<br />
        private static void PrintThree()<br />
        {<br />
            manualResetEvent3.Set();<br />
        }</pre>
<p>　　　　　　static ManualResetEvent manualResetEvent1 = new ManualResetEvent(false);<br />        　　　　　　static ManualResetEvent manualResetEvent2 = new ManualResetEvent(false);<br />        　　　　　　static ManualResetEvent manualResetEvent3 = new ManualResetEvent(false);</p>
<pre class="prettyprint linenums">&nbsp;</pre>
</div>
<p>看WaitAll的测试：</p>
<div>
<pre class="prettyprint linenums">        public static void WaitAllTest()<br />
        {<br />
            new Thread(new ThreadStart(PrintOne)).Start();<br />
            new Thread(new ThreadStart(PrintTwo)).Start();<br />
            new Thread(new ThreadStart(PrintThree)).Start();<br />
            var isOk = ManualResetEvent.WaitAll(new WaitHandle[] { manualResetEvent1, manualResetEvent2, manualResetEvent3 }, , false);<br />
            if (isOk){<br />
                Console.WriteLine("Oh,My God "+isOk);<br />
            }<br />
        }</pre>
</div>
<p>输出结果：Oh,My God True。</p>
<p>WaitAll是WaitHandle的静态方法，它接收WaitHandle数组，当所有的WaitHandle的信号都返回true时，WaitAll才返回True.</p>
<p>而另外一个方法 WaitAny（）方法与WaitAll的区别是，WaitAny当数组中一个WaitHandle获得信号的时候，就会返回，返回值为数组中有信号的WaitHandle的索引，当全部没有返回信号时，返回的是System.Threading.WaitHandle.WaitTimeout：</p>
<p>演示代码如下：</p>
<div>
<p>var hasSignalIndex = ManualResetEvent.WaitAny(new WaitHandle[] { manualResetEvent1, manualResetEvent2, manualResetEvent3 }, 2000, false);<br />            if (hasSignalIndex == System.Threading.WaitHandle.WaitTimeout)<br />            {<br />                Console.WriteLine("Oh, fail");<br />            }<br />            else<br />            {<br />                Console.WriteLine("Oh,My God " + hasSignalIndex);<br />            }</p>
</div>
<p>7.2 使用AutoResetEvent同步 --- 与ManualResetEvent 类似，不做演示。</p>
<p><strong>&nbsp;7.3 使用Mutex线程同步</strong></p>
<p><strong>对象：线程</strong></p>
<p><strong>使用方式：一次只有一个线程能够获得锁，只有获得锁的线程释放了锁其他的线程才能够获得锁。</strong></p>
<p>代码演示：</p>
<div>
<pre class="prettyprint linenums">        static Mutex myMutex;<br />
        public static void MutexThread()<br />
        {<br />
            myMutex = new Mutex(true, "myMutex");

            new Thread(new ThreadStart(PrintNo)).Start();

            for (int i = ; i &lt; 1; i++)<br />
            {<br />
                Console.WriteLine(i);<br />
            }

            myMutex.ReleaseMutex();<br />
        }

        private static void PrintNo()<br />
        {<br />
            myMutex.WaitOne();<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                Console.WriteLine(i);<br />
            }<br />
        }</pre>
</div>
<p>输出结果：</p>
<div>
<pre class="prettyprint linenums">
</pre>
</div>
<p>在上面的演示中，主线程先获得锁，接着启动线程，但是线程是没有锁的，所以先执行主线程的打印循环，当主线程释放锁的时候，线程才获得锁，这时候线程才执行。Mutex.WaitOne也有其他的重载方法，可自行探索。</p>
<p><strong>7.4 使用InterLocked同步Int类型变量：</strong></p>
<p><strong>对象：Int类型变量；</strong></p>
<p><strong>使用方式：InterLocked.Increment(ref a)等方法；</strong></p>
<p>代码演示：</p>
<div>
<pre class="prettyprint linenums">        private static int a = ;<br />
        public static void InterLockThread()<br />
        {<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                new Thread(new ThreadStart(IncreaseInt)).Start();<br />
            }

            for (int i = ; i &lt; ; i++)<br />
            {<br />
                new Thread(new ThreadStart(IncreaseInt)).Start();<br />
            }<br />
        }

        private static void IncreaseInt()<br />
        {<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                //a++;<br />
                Interlocked.Increment(ref a);<br />
            }<br />
            Console.WriteLine(string.Format("Thread：{0}  value: {1}", Thread.CurrentThread.GetHashCode(), a));<br />
        }</pre>
</div>
<p>在上面的 IncreaseInt 方法中有 a++ 和 Interlocked.Increment(ref a)两种方式，其中 Interlocked.Increment(ref a) 是原子操作。可能有人会想a++也才一句语句，怎么会不是原子操作，但是实际上我们的程序最后都是编译成了计算机能够认得的计算机指令，一句a++是有很多指令组成的。</p>
<p>结果演示：可以自己试着把a++和&nbsp;Interlocked.Increment(ref a)切换注释一下运行，结果很明显</p>
<p>7.5 使用ThreadStatic属性为类的静态变量创建副本，使得每一个线程的变量独立</p>
<p>对象：类静态变量；</p>
<p>使用方式：把要设置多个副本的类静态变量标记属性【ThreadStatic】</p>
<p>效果：标记了ThreadStatic的类静态变量各个线程独立不会因为其他线程堆值的改变而共享。</p>
<p>代码演示：</p>
<div>
<pre class="prettyprint linenums">        [ThreadStatic]<br />
        static int x;

        static int y;

        public static void StaticAttributeThread()<br />
        {<br />
            Task.Run(() =&gt; { IncreaseInt(); });<br />
            Task.Run(() =&gt; { IncreaseInt(); });<br />
        }

        private static void IncreaseInt()<br />
        {<br />
            for (int i = ; i &lt; ; i++)<br />
            {<br />
                Console.WriteLine(string.Format("current thread {0}，x={1}, y={2}",Thread.CurrentThread.GetHashCode(),x++,y++));<br />
            }<br />
        }</pre>
</div>
<p>输出结果：</p>
<div>
<pre class="prettyprint linenums">current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=<br />
current thread ，x=, y=</pre>
</div>
<p>可以看到，在不同的线程，y值是共享了修改结果的，而x是没有的。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mdz028.html">unity3d中串口的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdgejzq.html">php namespace用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96lkxy9.html">反射实现 AOP 动态代理模式&lpar;Spring AOP 的实现 原理&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kr4x7q.html">Cygwin的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o0lr58.html">GCD下的几种实现同步的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/390351o9.html">实现关闭窗口IE不提示兼容火狐</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyddzxmq.html">C&plus;&plus; STL pair</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvje49.html">win2003以isapi的方式配置php&plus;mysql环境（安装了shopEX）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm57pe9.html">AndroidTestCase简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnx7jv8.html">iostat来对linux硬盘IO性能进行了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwmxe8.html">关于怎么C&num;控制台窗口中怎么创建连接查询数据库操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdz2k9.html">Java编码问题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/96076d39.html">Linker Scripts3--SECTIONS Command</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ykv2q.html">疑问：VS在调试的过程中，总是会提示正在加载picface&period;dll的符号，然后卡死在那</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxm1d9.html">Highcharts之折线图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rezn08.html">mysqli&lowbar;query数据库有数据，查不出来</a>
		</li>
						<li><a href="https://www.batexi.com/a/9606v239.html">在Windows上安装Gradle</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1mlve9.html">造成ORA-01843 无效的月份 的一些原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pjror8.html">JSPatch - 基本使用和学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v57vzq.html">Java编程思想中关于闭包的一个例子</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpx0kj9.html">RestTemplate通过InputStreamResource上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m671n8.html">spring&period;http&period;multipart&period;maxFileSize提示无效报错问题处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6vwo8.html">Leetcode-1&period;两数之和</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkzex9.html">day04 流程控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjpj5x8.html">论文学习笔记--无缺陷样本产品表面缺陷检测 A Surface Defect Detection Method Based on Positive Samples</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgv5n48.html">Qt无法正确 sendMessage 的消息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj3v0k8.html">TCP-IP详解笔记8</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zlj7e9.html">Grunt 实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyz4nz9.html">dml并行</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgv4oe8.html">vs2017打包安卓项目简述</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
